package mainForm;

import java.io.File;
import java.io.FileOutputStream;
import java.io.IOException;
import java.util.ArrayList;

public class MIDIFile {
    private static final int[] fileHeader = { 'M', 'T', 'h', 'd' };
    private static final int PPQ = 480;
    private static final int TYPE = 1;
    private static final int LENGTH_BYTECOUNT = 4;
    private static final int TYPE_BYTECOUNT = 2;
    private static final int TRACKCOUNT_BYTECOUNT = 2;
    private static final int PPQ_BYTECOUNT = 2;

    public static int getPPQ() {
        return PPQ;
    }

    public ArrayList<MIDITrack> getTrackList() {
        return trackList;
    }

    private ArrayList<MIDITrack> trackList;

    MIDIFile() {
        trackList = new ArrayList<>();
    }

    public void generateMIDIFile(String pathname) throws IOException {
        File output = new File(pathname);

        FileOutputStream fout = new FileOutputStream(output);

        // header
        fout.write(MIDIUtil.intArrayToByteArray(fileHeader));
        fout.write(MIDIUtil.longToBytes(TYPE_BYTECOUNT + TRACKCOUNT_BYTECOUNT + PPQ_BYTECOUNT, LENGTH_BYTECOUNT));
        fout.write(MIDIUtil.longToBytes(TYPE, TYPE_BYTECOUNT));
        fout.write(MIDIUtil.longToBytes(trackList.size(), TRACKCOUNT_BYTECOUNT));
        fout.write(MIDIUtil.longToBytes(PPQ, PPQ_BYTECOUNT));

        for (MIDITrack track : trackList) {
            fout.write(track.getBytes());
        }

        fout.flush();
        fout.close();
    }
}
