package mainForm;

import java.util.ArrayList;

public class MIDITrack {
    private final int[] trackHeader = { 'M', 'T', 'r', 'k' };


    private ArrayList<MIDIEvent> eventsList;

    public ArrayList<MIDIEvent> getEventsList() {
        return eventsList;
    }

    MIDITrack() {
        eventsList = new ArrayList<>();
    }

    private int dataLength(){
        int buffer = 0;

        for (MIDIEvent event : eventsList) {
            buffer = buffer + event.byteCount();
        }

        return buffer;
    }

    public byte[] getBytes(){
        final int lengthByteCount = 4;

        byte[] dataLength = MIDIUtil.longToBytes(dataLength(), lengthByteCount);
        int byteCount = trackHeader.length + dataLength.length;

        for (MIDIEvent event : eventsList) {
            byteCount = byteCount + event.byteCount();
        }

        byte[] buffer = new byte[byteCount];

        System.arraycopy(MIDIUtil.intArrayToByteArray(trackHeader), 0, buffer, 0, trackHeader.length);
        System.arraycopy(dataLength, 0, buffer, trackHeader.length, dataLength.length);

        int pos = trackHeader.length + dataLength.length;
        for (MIDIEvent event : eventsList) {
            byte[] eventBuffer = event.getBytes();
            System.arraycopy(eventBuffer, 0, buffer, pos, eventBuffer.length);
            pos = pos + eventBuffer.length;
        }

        return buffer;
    }
}
