package mainForm;

public class MIDIUtil {
    public static int byteCount(long val) {
        final int bitCount = 8;
        int exponent = bitCount;
        double threshold = Math.pow(2, exponent);
        int counter = 1;

        while (val >= threshold) {
            exponent = exponent + bitCount;
            threshold = Math.pow(2, exponent);
            counter++;
        }

        return counter;
    }

    public static long encodeVLQ(long val) {
        double output = 0;
        double value = val;
        int counter = 0;
        final int bitCount = 7;
        int exponent = 0;
        double signBit;
        double modulo;

        do {
            exponent = exponent + bitCount;
            signBit = Math.pow(2, exponent);
            modulo = (value % signBit);
            value = value - modulo;
            output = output + (modulo * Math.pow(2, counter));

            if (counter > 0) {
                output = output + (signBit * Math.pow(2, counter));
            }

            counter++;
        }
        while (value >= signBit);

        return (long) output;
    }

    public static byte[] longToBytes(long val, int byteCount) {
        byte[] buffer = new byte[byteCount];
        int[] ints = new int[byteCount];

        for (int i = 0; i < byteCount; i++) {
            ints[i] = (int) val & 0xFF;
            buffer[byteCount - i - 1] = (byte) ints[i];

            val = val >> 8;

            if (val == 0) {
                break;
            }
        }

        return buffer;
    }

    public static byte[] intArrayToByteArray (int[] ints)
    {
        int len = ints.length;
        byte[] out = new byte[ints.length];
        for (int i = 0; i < len; i++)
        {
            out[i] = (byte) ints[i];
        }
        return out;
    }

    private MIDIUtil(){}
}