package mainForm;

import java.util.ArrayList;

public class Score extends ArrayList<NoteList>{

    public double length(){
        double length = 0;
        for (NoteList a : this) {
            double currLength = 0;
            for (Note n : a) {
                currLength = currLength + n.getDuration();
            }

            if (currLength > length){
                length = currLength;
            }
        }

        return length;
    }

    private void finalizeVoices(){
        double length = length();

        for (NoteList voice : this) {
            voice.fillRests(length);
        }
    }

    public void add(Score score){
        finalizeVoices();

        while (this.size() < score.size()){
            this.add(new NoteList());
        }

        for (int i = 0; i < score.size(); i++) {
            this.get(i).addNotes(score.get(i));
        }

        finalizeVoices();
    }

    public void keyShift(int value){
        value = value % 8;

        for (NoteList voice : this) {
            for (Note n : voice) {
                if (n.getTone() != -1) {
                    n.setTone(n.getTone() + value);

                    while (n.getTone() < 0){
                        n.setTone(n.getTone() + 12);
                    }

                    while (n.getTone() > 127){
                        n.setTone(n.getTone() -12);
                    }
                }
            }
        }
    }
}