import mainForm.MIDIUtil;
import org.junit.Test;
import static org.junit.Assert.*;

public class MIDIUtilTest {
    @Test
    public void byteCountTest(){
        assertEquals(1, MIDIUtil.byteCount(0));
        assertEquals(1, MIDIUtil.byteCount(255));
        assertEquals(2, MIDIUtil.byteCount(256));
        assertEquals(3, MIDIUtil.byteCount(65536));
    }

    @Test
    public void encodeVLQTest(){
        assertEquals(127, MIDIUtil.encodeVLQ(127));
        assertEquals(33024, MIDIUtil.encodeVLQ(128));
        assertEquals(8486912, MIDIUtil.encodeVLQ(16384));
        assertEquals(16777087, MIDIUtil.encodeVLQ(2097151));
    }

    @Test
    public void longToBytesTest(){
        byte[] firstArray = {0x0,0xF,0x0};
        byte[] secondArray = {0x0};
        byte[] thirdArray = {};
        assertArrayEquals(firstArray, MIDIUtil.longToBytes(3840, 3));
        assertArrayEquals(secondArray, MIDIUtil.longToBytes(0, 1));
        assertArrayEquals(secondArray, MIDIUtil.longToBytes(2048, 1));
        assertArrayEquals(thirdArray, MIDIUtil.longToBytes(2048, 0));
    }

    @Test
    public void intArrayToByteArrayTest(){
        int[] intArray = {0x0,0x4,0xD2};
        byte[] byteArray = MIDIUtil.intArrayToByteArray(intArray);

        for (int i = 0; i < byteArray.length; i++) {
            assertEquals(byteArray[i], (byte) intArray[i]);
        }
    }
}
